/*
Module : SocksRequest.cpp
Purpose: Implementation for the CSocksRequest class
Created: PJN / 16-02-2003
History: PJN / 13-01-2004 1. Used newer form of #pragma pack to avoid problems with non standard 
                             packing sizes.
         PJN / 15-01-2007 1. Optimized CSocksConnectionRequest constructor code
                          2. Optimized CSocks5RequestDetails constructor code

Copyright (c) 2003 - 2017 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code. 

*/


//////////////// Includes /////////////////////////////////////////////////////

#include "stdafx.h"
#include "SocksRequest.h"


//////////////// Macros ///////////////////////////////////////////////////////

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


//////////////// Implementation ///////////////////////////////////////////////

CSocksConnectionRequest::CSocksConnectionRequest() : m_bSocks5Request(false)
{
  memset(&m_Socks4Request, 0, sizeof(m_Socks4Request));
  memset(&m_Socks5Request, 0, sizeof(m_Socks5Request));
}

CSocks5RequestDetails::CSocks5RequestDetails() : m_Type(Unknown)
{
  memset(&IP_4, 0, sizeof(IP_4));
  memset(&IP_6, 0, sizeof(IP_6));
  memset(&HOSTNAME, 0, sizeof(HOSTNAME));
}