/*
Module : SocksSocket.h
Purpose: Defines the interface for a socks socket class

Copyright (c) 2003 - 2017 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code. 

*/


/////////////////////////////// Macros / Defines //////////////////////////////

#pragma once

#ifndef __SOCKSSOCKET_H__
#define __SOCKSSOCKET_H__


/////////////////////////////// Includes //////////////////////////////////////

#include "SocMFC.h"       //If the code fails to compile because of this missing include then you need to download 
                          //the CWaitableTimer class from my web site and copy the relevant files to the SocksSvc directory
#include "SocksRequest.h"
#include "WTimer.h"       //If the code fails to compile because of this missing include then you need to download 
                          //the CWaitableTimer class from my web site and copy the relevant files to the SocksSvc directory


/////////////////////////////// Classes ///////////////////////////////////////

class CSocksSocket : public CWSocket
{
public:
//methods
  bool Read(_In_ CSocksConnectionRequest& request, _In_ DWORD dwTimeout, _In_ CWaitableTimer& timer, _In_ HANDLE hStopEvent, _In_ HANDLE hDataEvent);
  bool Read(_In_ CSocks5RequestDetails& request, _In_ DWORD dwTimeout, _In_ CWaitableTimer& timer, _In_ HANDLE hStopEvent, _In_ HANDLE hDataEvent);
  bool Read(_In_ CSocksUsernameAuthenticationDetails& request, _In_ DWORD dwTimeout, _In_ CWaitableTimer& timer, _In_ HANDLE hStopEvent, _In_ HANDLE hDataEvent);
  void SendWithRetry(_In_reads_bytes_(nBufLen) const void* pBuffer, _In_ int nBufLen, _In_ DWORD dwTimeout);

protected:
//Member variables
  CEvent m_WSABlockEvent;  //Used to implement SendWithRetry
};

#endif //#ifndef __SOCKSSOCKET_H__
